贪心算法|53.最大子序和

力扣题目链接

cpp 复制代码
class Solution {
public:
    int maxSubArray(vector<int>& nums) {
       int result = INT32_MIN;
       int count = 0;
       for (int i = 0; i < nums.size(); i++) {
        count += nums[i];
        if (count > result) {
            result = count;
        }
        if (count <= 0) count = 0;
       }
       return result;
    }
};

这题的暴力解法很好理解,以上是贪心解法的代码。

贪心解法

贪心贪的是哪里呢?

如果 -2 1 在一起,计算起点的时候,一定是从 1 开始计算,因为负数只会拉低总和,这就是贪心贪的地方!

局部最优:当前"连续和"为负数的时候立刻放弃,从下一个元素重新计算"连续和",因为负数加上下一个元素 "连续和"只会越来越小。

全局最优:选取最大"连续和"

局部最优的情况下,并记录最大的"连续和",可以推出全局最优。

从代码角度上来讲:遍历 nums,从头开始用 count 累积,如果 count 一旦加上 numsi变为负数,那么就应该从 numsi+1开始从 0 累积 count 了,因为已经变为负数的 count,只会拖累总和。

这相当于是暴力解法中的不断调整最大子序和区间的起始位置。

那有同学问了,区间终止位置不用调整么? 如何才能得到最大"连续和"呢?

区间的终止位置,其实就是如果 count 取到最大值了,及时记录下来了。例如如下代码:

复制代码
if (count > result) result = count;

这样相当于是用 result 记录最大子序和区间和(变相的算是调整了终止位置)。

如动画所示:

红色的起始位置就是贪心每次取 count 为正数的时候,开始一个区间的统计。

自己的思路:

贪心算法的关键代码在for循环里面

只有count是正数时才继续进行

当count小于0时,count=0,这里也是理解的关键

复制代码
if (count <= 0) count = 0; // 相当于重置最大子序起始位置,因为遇到负数一定是拉低总和

很好的理解咯,独自敲代码,没有出一点错误~

相关推荐
信奥卷王6 小时前
[GESP202609 六级] 分树规划
算法
夏幻灵6 小时前
LeetCode 21:合并两个有序链表——双指针与哑节点详解
算法·leetcode·链表
徐小黑ACG8 小时前
Golang 基础05 结构体struct
开发语言·算法·golang
Navigator_Z8 小时前
LeetCode //C - 1286. Iterator for Combination
c语言·算法·leetcode
北极有牛9 小时前
cpp学习笔记--常量指针
java·开发语言·算法
GPU实战笔记9 小时前
云端 GPU 训练的账户余额提醒:它能说明什么,不能说明什么?
深度学习·算法·成本管理·gpu云计算·云端训练
浮链序9 小时前
怎么证明"你这个模型是偷我的"——把蒸馏变成取证工具
算法·安全·llm
小O的算法实验室9 小时前
IEEE TMC,面向异构物联网的多目标量子行为拓扑优化算法
算法
liliangcsdn10 小时前
派息率指标的应用探索和分析
大数据·算法